﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий сотрудника в системе
	/// </summary>
	[DataContract]
	[EntityDescription("Employee", "Сотрудника в системе")]
	public class Employee : BaseEntity, IEntitySecurityExtenstion<Employee>
    {
        [DataMember]
        [MapConfiguration("UserId")]
        public Guid UserId { get; set; }

        [DataMember]
        [MapConfiguration("FirstName")]
        public string FirstName { get; set; }

        [DataMember]
        [MapConfiguration("LastName")]
        public string LastName { get; set; }

        [DataMember]
        [MapConfiguration("Patronymic")]
        public string Patronymic { get; set; }

        [DataMember]
        [MapConfiguration("DateBirth")]
        public DateTime DateBirth { get; set; }

        [DataMember]
        [MapConfiguration("Address")]
        public string Address { get; set; }

        [DataMember]
        [MapConfiguration("Email")]
        public string Email { get; set; }

        [DataMember]
        [MapConfiguration("MobileNumber")]
        public string MobileNumber { get; set; }

        [DataMember]
        [MapConfiguration("HomeNumber")]
        public string HomeNumber { get; set; }

        [DataMember]
        [MapConfiguration("Description")]
        public string Description { get; set; }

        [DataMember]
        [MapConfiguration("Photo")]
        public byte[] Photo { get; set; }

        [DataMember]
        [MapConfiguration("GroupElectricalSafety")]
        public string GroupElectricalSafety { get; set; }

        //-------------------------------------------------------------------------

        //-------------------------------------------------------------------------

        [ForeignKey("EmployeeId")]
        public virtual List<EmployeeEmployeePost> EmployeeEmployeePosts { get; set; }

        //-------------------------------------------------------------------------

        public Employee SecurityCheck(Employee entity, bool allowFullData)
        {
            if (!allowFullData)
            {
                entity.DateBirth = DateTime.Now;
                entity.Address = "скрыто";
                entity.Email = "скрыто";
                entity.MobileNumber = "скрыто";
                entity.HomeNumber = "скрыто";
                entity.Photo = null;
            }

            return entity;
        }
    }
}
