﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Security
{
	/// <summary>
	/// Класс, описывающий общие настройки системы
	/// </summary>
	[DataContract]
	[EntityDescription("EnviromentSetting", "Общие настройки системы")]
	public class EnviromentSetting : IdEntity, IEntitySecurityExtenstion<EnviromentSetting>
	{
		[DataMember]
		[MapConfiguration("Key")]
		[Required]
		public string Key { get; set; }

		[DataMember]
		[MapConfiguration("Value")]
		[Required]
		public string Value { get; set; }

		[DataMember]
		[MapConfiguration("Description")]
		public string Description { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		public EnviromentSetting SecurityCheck(EnviromentSetting entity, bool allowFullData)
		{
			if (!allowFullData)
			{
				entity.Value = "скрыто";
			}
			return entity;
		}
	}
}