﻿namespace DesktopTools.Interfaces
{
	/// <summary>
	/// Работа с контролами вывода свойства элемента
	/// </summary>
	public interface IBaseControl
	{
		/// <summary>
		/// Установка _originalValue в значение по умолчанию
		/// </summary>
		void SetDefaultValue();

		/// <summary>
		/// Установка значения в контрол
		/// </summary>
		/// <param name="value"></param>
		void SetValueToControl(object value);

		/// <summary>
		/// Сброс значения
		/// </summary>
		void DropValueForControl();

		/// <summary>
		/// Проверка на заполненность
		/// </summary>
		/// <returns></returns>
		bool CheckValueForControl();

		/// <summary>
		/// Получение значение с контрола
		/// </summary>
		/// <returns></returns>
		object GetValueFromControl();

		/// <summary>
		/// Получение имени свойства
		/// </summary>
		/// <returns></returns>
		string GetPropertyName();
	}
}