﻿using ModuleTools.Interfaces;
using System.Collections.Generic;

namespace ModuleTools.BusinessLogics
{
	/// <summary>
	/// Основа всех бизнес-логик
	/// </summary>
	public class CoreBusinessLogic
	{
		/// <summary>
		/// Менеджер безопасности
		/// </summary>
		protected readonly ISecurityManager _security;

		/// <summary>
		/// Перечень ошибок при выполнении операции
		/// </summary>
		public List<(string Title, string Message)> Errors { get; protected set; }

		/// <summary>
		/// Основа всех бизнес-логик
		/// </summary>
		/// <param name="service"></param>
		public CoreBusinessLogic()
		{
			_security = DependencyManager.Instance.Resolve<ISecurityManager>();
			Errors = new();
		}
	}
}