﻿using ModuleTools.Attributes;
using ModuleTools.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace DepartmentBusinessLogic.BindingModels
{
	/// <summary>
	/// Получение связи сотрудника с должностью
	/// </summary>
	public class EmployeeEmployeePostGetBindingModel : GetBindingModel
	{
		public Guid? EmployeeId { get; set; }

		public Guid? EmployeePostId { get; set; }
	}

	/// <summary>
	/// Сохранение связи сотрудника с должностью
	/// </summary>
	public class EmployeeEmployeePostSetBindingModel : SetBindingModel
	{
		[Required(ErrorMessage = "required")]
		[MapConfiguration("EmployeeId")]
		public Guid EmployeeId { get; set; }

		[Required(ErrorMessage = "required")]
		[MapConfiguration("EmployeePostId")]
		public Guid EmployeePostId { get; set; }

		[Required(ErrorMessage = "required")]
		[MapConfiguration("Rate")]
		public decimal Rate { get; set; }

		[MapConfiguration("IsInternalCombination")]
		public bool IsInternalCombination { get; set; }

		[MapConfiguration("IsExternalCombination")]
		public bool IsExternalCombination { get; set; }
	}
}